<template>
  <div
    :class="[
      'flex flex-col items-center p-2',
      {
        'animate-pulse bg-neutral-20 text-neutral-20': loading,
      },
    ]"
  >
    <div
      v-if="!loading && mediafiles.length > 0"
      class="flex flex-col items-end mt-2 overflow-y-auto"
    >
      <draggable
        v-model="mediafiles"
        item-key="mediafiles-container"
        class="sortable"
        :disabled="!setDraggable()"
        @end="endDrag"
      >
        <template #item="{ element }">
          <div
            :key="element.filename ? element.filename : 'no-filename'"
            :class="[' px-5 py-2 flex flex-col justify-end']"
          >
            <div class="relative group">
              <trash-icon
                v-if="editMode === 'edit' && !toBeDeleted.includes(element._id)"
                class="hidden group-hover:block"
                @click="addToSaveCallback(element._id)"
              />
              <AudioThumbnail
                v-if="
                  element.thumbnail_file_location &&
                  element?.mimetype.includes('audio')
                "
                :class="[
                  'obtain-cover outline-none shadow-sm rounded cursor-pointer w-full border-2',
                  toBeDeleted.includes(element._id)
                    ? 'filter blur-xs grayscale'
                    : '',
                  selectedImage && element.filename === selectedImage.filename
                    ? 'border-2 border-blue-500'
                    : '',
                ]"
                @click="selectImage(element)"
              />
              <SvgThumbnail
                v-else-if="
                  element.thumbnail_file_location &&
                  element?.mimetype.includes('text/plain')
                "
                :class="[
                  'obtain-cover outline-none shadow-sm rounded cursor-pointer w-full border-2',
                  toBeDeleted.includes(element._id)
                    ? 'filter blur-xs grayscale'
                    : '',
                  selectedImage && element.filename === selectedImage.filename
                    ? 'border-2 border-blue-500'
                    : '',
                ]"
                @click="selectImage(element)"
              />
              <img
                v-else-if="element.thumbnail_file_location"
                :class="[
                  'obtain-cover outline-none shadow-sm rounded cursor-pointer w-full',
                  toBeDeleted.includes(element._id)
                    ? 'filter blur-xs grayscale'
                    : '',
                  selectedImage && element.filename === selectedImage.filename
                    ? 'border-2 border-blue-500'
                    : '',
                ]"
                :src="
                  !element.mimetype.includes('pdf')
                    ? `/api/iiif/3/${
                        element.transcode_filename || element.filename
                      }/square/100,/0/default.jpg`
                    : element.thumbnail_file_location
                "
                @click="selectImage(element)"
              />
            </div>
          </div>
        </template>
      </draggable>
    </div>
    <div :class="editMode === 'edit' ? 'pb-20 pt-5' : ''">
      <plus-circle-icon
        v-if="editMode === 'edit'"
        @click="openUploadModalWrapper()"
      />
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, onMounted, ref, reactive } from "vue";
import type { PropType } from "vue";
import { useMutation } from "@vue/apollo-composable";
import { DeleteDataDocument, Collection } from "../queries";
import type { MediaFile } from "../queries";
import type { DeleteDataMutation } from "../queries";
import AudioThumbnail from "../components/base/audiothumbnail.vue";
import SvgThumbnail from "./base/svgThumbnail.vue";
import TrashIcon from "../components/base/TrashIcon.vue";
import PlusCircleIcon from "../components/base/PlusCircleIcon.vue";
import { useEditMode } from "../composables/useEdit";
import { useUploadModal, modalChoices } from "./UploadModal.vue";
import useDropzoneHelper from "../composables/useDropzoneHelper";
import useMediaAssetLinkHelper from "../composables/useMediaAssetLinkHelper";
import useMetaDataHelper from "../composables/useMetaDataHelper";
import useMediafilesOrderHelpers from "../composables/useMediafilesOrderHelpers";
import draggable from "vuedraggable/src/vuedraggable";
export const toBeDeleted = ref<string[]>([]);

type MediafileSelectionState = {
  selectedMediafile: MediaFile | undefined;
};

const mediafileSelectionState = reactive<MediafileSelectionState>({
  selectedMediafile: undefined,
});

export const useEntityMediafileSelector = () => {
  const updateSelectedEntityMediafile = (mediafile: MediaFile | undefined) => {
    mediafileSelectionState.selectedMediafile = mediafile;
  };

  return { mediafileSelectionState, updateSelectedEntityMediafile };
};

export default defineComponent({
  name: "EntityImageSelection",
  components: {
    AudioThumbnail,
    PlusCircleIcon,
    TrashIcon,
    draggable,
    SvgThumbnail,
  },
  props: {
    selectedImage: {
      type: Object as PropType<MediaFile | null>,
      required: true,
    },
    loading: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const { selectedFiles } = useDropzoneHelper();
    const { mediafiles, beingAdded } = useMetaDataHelper();
    const { updateSelectedEntityMediafile } = useEntityMediafileSelector();
    const { isMediaFileInLinkList, removeMediaFileFromLinkList } =
      useMediaAssetLinkHelper();
    const { removeFromMetaDataPatchList } = useMetaDataHelper();
    const { openUploadModal } = useUploadModal();
    const selectImage = (mediafile: MediaFile) => {
      updateSelectedEntityMediafile(mediafile);
    };

    const { compareMediafileOrder } = useMediafilesOrderHelpers();

    const { editMode, addSaveCallback } = useEditMode();

    const { mutate } = useMutation<DeleteDataMutation>(DeleteDataDocument);

    const addToSaveCallback = (id: string) => {
      const parsedId = id.replace("mediafiles/", "");
      removeFromMetaDataPatchList(parsedId);
      toBeDeleted.value.push(id);
      if (!isMediaFileInLinkList(id)) {
        addSaveCallback(async () => {
          await mutate({ id: parsedId, path: Collection.Mediafiles });
        });
      } else {
        removeMediaFileFromLinkList(id);
      }
    };

    onMounted(() => {
      if (props.selectedImage) {
        updateSelectedEntityMediafile(props.selectedImage);
      }
    });

    const endDrag = () => {
      compareMediafileOrder(mediafiles.value);
    };

    const setDraggable = (): boolean => {
      if (editMode.value === "edit") {
        return true;
      } else {
        return false;
      }
    };

    const openUploadModalWrapper = () => {
      beingAdded.value = "mediafile";
      openUploadModal(modalChoices.DROPZONE);
    };

    return {
      selectImage,
      editMode,
      addToSaveCallback,
      toBeDeleted,
      openUploadModalWrapper,
      modalChoices,
      selectedFiles,
      endDrag,
      setDraggable,
      mediafiles,
    };
  },
});
</script>

<style scoped>
.sortable-drag {
  opacity: 0;
}
</style>
